/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright (c) 2008 by Nuvoton Technology Corporation                                                    */
/* All rights reserved                                                                                     */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
/* File Contents:                                                                                          */
/*   wb_platform.c                                                                                         */
/*          The platform related functions.                                                                */
/*                                                                                                         */
/* Version:                                                                                                */
/*          v0.0.2                                                                                         */
/*                                                                                                         */
/* Project:                                                                                                */
/*          DA8205                                                                                         */
/*                                                                                                         */
/*                                                                               $Date: 08/10/30 4:34p $   */
/*---------------------------------------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------------------------------------*/
/* Check semihosting function. For standalone application                                                  */
/*---------------------------------------------------------------------------------------------------------*/
#if 1
#pragma import(__use_no_semihosting_swi)
#endif
#include <stdio.h>
#include <rt_misc.h>

extern void DrvSIO_PutChar(char ch);

#define USE_SERIAL_PORT
#define uputchar	DrvSIO_PutChar
#define ugetchar	DrvSIO_GetChar

struct __FILE { int handle;   /* Add whatever you need here */};

FILE __stdout;


__value_in_regs struct __initial_stackheap __user_initial_stackheap (
    unsigned R0,
    unsigned SP,
    unsigned R2,
    unsigned SL
    )
{
    struct __initial_stackheap config;

    extern unsigned int Image$$RAM$$ZI$$Limit;

    config.heap_base = (unsigned int)&Image$$RAM$$ZI$$Limit;
    config.heap_limit = SP;
    config.stack_base = SP;
    config.stack_limit = SL;

    return config;
}


//unsigned int aaaa;

int fputc(int ch, FILE *f)
{
    /* Place your implementation of fputc here     */
    /* e.g. write a character to a UART, or to the */
    /* debugger console with SWI WriteC            */

    char tempch = ch;
#ifdef USE_SERIAL_PORT
    extern void uputchar(char ch);
	uputchar(tempch); // output to UART
#else
    WriteC( &tempch );
#endif
    return ch;
}


int ferror(FILE *f)
{   /* Your implementation of ferror */
    return EOF;
}



void _ttywrch(int ch)
{
    char tempch = ch;
#ifdef USE_SERIAL_PORT
    DrvSIO_PutChar( tempch );
#else
    WriteC( &tempch );
#endif
}


// Returns the number of characters transmitted.
int print_sys_buf(unsigned int count, unsigned char *stream_ptr)
{
    do
    {
		DrvSIO_PutChar(*(char *)stream_ptr);
		count--;
		stream_ptr++;
    }while (count != 0);
    return count;
}


// Routine to fill the stream buffer from the com port.
// Returns the first character read.
int fil_sys_buf(unsigned int max_count, unsigned char *stream_ptr)
{
    unsigned int ch, count = 0;
	extern int ugetchar(void);
    do
    {
		ch = ugetchar();
		
		switch (ch)
		{
	    	case 0x8:
				// Delete code.
				if (count > 0)
				{
			    	stream_ptr--;
				    count--;
				}
				DrvSIO_PutChar(*(char *)&ch);
				break;
	    case 0xd:
				// Carriage return code, change to 0xa.
				ch = 0xa;
				count--;
	    default:
				DrvSIO_PutChar(*(char *)&ch);
				*stream_ptr++ = ch;
				count++;
				break;
		}
    }while (ch != 0xa);
    stream_ptr -= count;
    return max_count - (count + 1);
}
